/*
* ----------------------------------------------------------------------------
* "THE BEER-WARE LICENSE" (Revision 42):
* <timkgle@gmail.com> wrote this file. As long as you retain this notice you
* can do whatever you want with this stuff. If we meet some day, and you think
* this stuff is worth it, you can buy me a beer in return Tim Kluge
* ----------------------------------------------------------------------------
*/

library linetransformer;

import "dart:async";

/**
 * Splits up incoming lines and returns them as strings (without
 * LF or CR). Lines can be sepeeperated by CRLF or LF.
 */

class LineTransformer extends StreamEventTransformer<String, String> {
  static const String LineFeed = "\n";
  static const String CarriageReturn = "\r";

  final StringBuffer _buffer = new StringBuffer();
  bool _lastonecarriage = false;

  void handleData(String data, EventSink<String> sink) {
    final int pos = data.indexOf(LineFeed);
    if(pos >= 0){
      // Es kommt ein Zeilenumbruch im neuen data-String vor
      String addition = _buffer.toString() + data.substring(0, pos);
      String rest = data.substring(pos+1);
      _buffer.clear();
      // Wenn ein CR unmittelbar vor LF folgt, das rauspicken
      if(addition.length >= 1 && addition[addition.length-1] == CarriageReturn){
        addition = addition.substring(0, addition.length-1);
      }
      sink.add(addition);
      if(rest.length > 0){
        handleData(rest, sink);
      }
    } else { // Oder auch nicht - einfach alles raufschaufeln
      _buffer.write(data);
      _lastonecarriage = data[data.length-1] == CarriageReturn;
    }
  }

  void handleDone(EventSink<String> sink) {
    final String remaining = _buffer.toString();
    if(remaining.length > 0){
      sink.addError(remaining);
    }
    sink.close();
  }
}