/*
* ----------------------------------------------------------------------------
* "THE BEER-WARE LICENSE" (Revision 42):
* <timkgle@gmail.com> wrote this file. As long as you retain this notice you
* can do whatever you want with this stuff. If we meet some day, and you think
* this stuff is worth it, you can buy me a beer in return Tim Kluge
* ----------------------------------------------------------------------------
*/

library linetransformertest;

import "package:unittest/unittest.dart";
import "../lib/linetransformer.dart";
import "dart:async";

void main(){
  test("One line per event", (){
    final List<String> input = ["foo\n", "bar\r\n", "hello\r\n", "world\r\n", "test\rwelt\r\n"];
    final Stream inputstream = new Stream.fromIterable(input);
    return inputstream
        .transform(new LineTransformer())
        .toList()
        .then((List<String> output){
          expect(output, ["foo", "bar", "hello", "world", "test\rwelt"]);
        });
  });
  
  test("Multiple lines per event", (){
    final List<String> input = ["foo\nbar\r\nhi\nworld\r\n","world\ntest\r\n"];
    final Stream inputstream = new Stream.fromIterable(input);
    return inputstream
        .transform(new LineTransformer())
        .toList()
        .then((List<String> output){
          expect(output, ["foo", "bar", "hi", "world", "world", "test"]);
        });
  });
  
  test("Mixed", (){
    final List<String> input = ["foo\nbar\r\nhi\nworld\r\nSonne, Mond und ","Sterne\nworld\ntest\r\n"];
    final Stream inputstream = new Stream.fromIterable(input);
    return inputstream
        .transform(new LineTransformer())
        .toList()
        .then((List<String> output){
          expect(output, ["foo", "bar", "hi", "world", "Sonne, Mond und Sterne", "world", "test"]);
        });
  });
}